Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/async.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,5 @@
 
 #if ((defined(LIBC_IPC_H_)) && (!defined(LIBC_ASYNC_C_)))
-#error Do not intermix low-level IPC interface and async framework
+	#error Do not intermix low-level IPC interface and async framework
 #endif
 
@@ -146,6 +146,6 @@
     sysarg_t, sysarg_t, sysarg_t, ipc_call_t *);
 
-extern void async_wait_for(aid_t, errno_t *);
-extern errno_t async_wait_timeout(aid_t, errno_t *, suseconds_t);
+extern void async_wait_for(aid_t, sysarg_t *);
+extern int async_wait_timeout(aid_t, sysarg_t *, suseconds_t);
 extern void async_forget(aid_t);
 
@@ -162,22 +162,22 @@
 extern void async_put_client_data_by_id(task_id_t);
 
-extern errno_t async_create_port(iface_t, async_port_handler_t, void *,
+extern int async_create_port(iface_t, async_port_handler_t, void *,
     port_id_t *);
 extern void async_set_fallback_port_handler(async_port_handler_t, void *);
-extern errno_t async_create_callback_port(async_exch_t *, iface_t, sysarg_t,
+extern int async_create_callback_port(async_exch_t *, iface_t, sysarg_t,
     sysarg_t, async_port_handler_t, void *, port_id_t *);
 
-extern errno_t async_irq_subscribe(int, async_notification_handler_t, void *,
-    const irq_code_t *, cap_handle_t *);
-extern errno_t async_irq_unsubscribe(cap_handle_t);
-
-extern errno_t async_event_subscribe(event_type_t, async_notification_handler_t,
+extern int async_irq_subscribe(int, async_notification_handler_t, void *,
+    const irq_code_t *);
+extern int async_irq_unsubscribe(int);
+
+extern int async_event_subscribe(event_type_t, async_notification_handler_t,
     void *);
-extern errno_t async_event_task_subscribe(event_task_type_t,
+extern int async_event_task_subscribe(event_task_type_t,
     async_notification_handler_t, void *);
-extern errno_t async_event_unsubscribe(event_type_t);
-extern errno_t async_event_task_unsubscribe(event_task_type_t);
-extern errno_t async_event_unmask(event_type_t);
-extern errno_t async_event_task_unmask(event_task_type_t);
+extern int async_event_unsubscribe(event_type_t);
+extern int async_event_task_unsubscribe(event_task_type_t);
+extern int async_event_unmask(event_type_t);
+extern int async_event_task_unmask(event_task_type_t);
 
 /*
@@ -198,12 +198,12 @@
  */
 
-extern errno_t async_answer_0(cap_handle_t, errno_t);
-extern errno_t async_answer_1(cap_handle_t, errno_t, sysarg_t);
-extern errno_t async_answer_2(cap_handle_t, errno_t, sysarg_t, sysarg_t);
-extern errno_t async_answer_3(cap_handle_t, errno_t, sysarg_t, sysarg_t,
+extern sysarg_t async_answer_0(cap_handle_t, sysarg_t);
+extern sysarg_t async_answer_1(cap_handle_t, sysarg_t, sysarg_t);
+extern sysarg_t async_answer_2(cap_handle_t, sysarg_t, sysarg_t, sysarg_t);
+extern sysarg_t async_answer_3(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t);
-extern errno_t async_answer_4(cap_handle_t, errno_t, sysarg_t, sysarg_t,
+extern sysarg_t async_answer_4(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern errno_t async_answer_5(cap_handle_t, errno_t, sysarg_t, sysarg_t,
+extern sysarg_t async_answer_5(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
 
@@ -212,7 +212,7 @@
  */
 
-extern errno_t async_forward_fast(cap_handle_t, async_exch_t *, sysarg_t, sysarg_t,
+extern int async_forward_fast(cap_handle_t, async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, unsigned int);
-extern errno_t async_forward_slow(cap_handle_t, async_exch_t *, sysarg_t, sysarg_t,
+extern int async_forward_slow(cap_handle_t, async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t, unsigned int);
 
@@ -338,8 +338,8 @@
 	    rc3, rc4, rc5)
 
-extern errno_t async_req_fast(async_exch_t *, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t async_req_fast(async_exch_t *, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t *, sysarg_t *, sysarg_t *, sysarg_t *,
     sysarg_t *);
-extern errno_t async_req_slow(async_exch_t *, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t async_req_slow(async_exch_t *, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t *, sysarg_t *, sysarg_t *,
     sysarg_t *, sysarg_t *);
@@ -355,7 +355,7 @@
 extern async_sess_t *async_connect_kbox(task_id_t);
 
-extern errno_t async_connect_to_me(async_exch_t *, sysarg_t, sysarg_t, sysarg_t);
-
-extern errno_t async_hangup(async_sess_t *);
+extern int async_connect_to_me(async_exch_t *, sysarg_t, sysarg_t, sysarg_t);
+
+extern int async_hangup(async_sess_t *);
 extern void async_poke(void);
 
@@ -382,12 +382,12 @@
 	async_share_in_start(exch, size, arg, flags, dst)
 
-extern errno_t async_share_in_start(async_exch_t *, size_t, sysarg_t,
+extern int async_share_in_start(async_exch_t *, size_t, sysarg_t,
     unsigned int *, void **);
 extern bool async_share_in_receive(cap_handle_t *, size_t *);
-extern errno_t async_share_in_finalize(cap_handle_t, void *, unsigned int);
-
-extern errno_t async_share_out_start(async_exch_t *, void *, unsigned int);
+extern int async_share_in_finalize(cap_handle_t, void *, unsigned int);
+
+extern int async_share_out_start(async_exch_t *, void *, unsigned int);
 extern bool async_share_out_receive(cap_handle_t *, size_t *, unsigned int *);
-extern errno_t async_share_out_finalize(cap_handle_t, void **);
+extern int async_share_out_finalize(cap_handle_t, void **);
 
 /*
@@ -422,10 +422,10 @@
 
 extern aid_t async_data_read(async_exch_t *, void *, size_t, ipc_call_t *);
-extern errno_t async_data_read_start(async_exch_t *, void *, size_t);
+extern int async_data_read_start(async_exch_t *, void *, size_t);
 extern bool async_data_read_receive(cap_handle_t *, size_t *);
 extern bool async_data_read_receive_call(cap_handle_t *, ipc_call_t *, size_t *);
-extern errno_t async_data_read_finalize(cap_handle_t, const void *, size_t);
-
-extern errno_t async_data_read_forward_fast(async_exch_t *, sysarg_t, sysarg_t,
+extern int async_data_read_finalize(cap_handle_t, const void *, size_t);
+
+extern int async_data_read_forward_fast(async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, ipc_call_t *);
 
@@ -461,14 +461,14 @@
 	    answer)
 
-extern errno_t async_data_write_start(async_exch_t *, const void *, size_t);
+extern int async_data_write_start(async_exch_t *, const void *, size_t);
 extern bool async_data_write_receive(cap_handle_t *, size_t *);
 extern bool async_data_write_receive_call(cap_handle_t *, ipc_call_t *, size_t *);
-extern errno_t async_data_write_finalize(cap_handle_t, void *, size_t);
-
-extern errno_t async_data_write_accept(void **, const bool, const size_t,
+extern int async_data_write_finalize(cap_handle_t, void *, size_t);
+
+extern int async_data_write_accept(void **, const bool, const size_t,
     const size_t, const size_t, size_t *);
-extern void async_data_write_void(errno_t);
-
-extern errno_t async_data_write_forward_fast(async_exch_t *, sysarg_t, sysarg_t,
+extern void async_data_write_void(sysarg_t);
+
+extern int async_data_write_forward_fast(async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, ipc_call_t *);
 
@@ -476,9 +476,9 @@
 extern async_sess_t *async_callback_receive_start(exch_mgmt_t, ipc_call_t *);
 
-extern errno_t async_state_change_start(async_exch_t *, sysarg_t, sysarg_t,
+extern int async_state_change_start(async_exch_t *, sysarg_t, sysarg_t,
     sysarg_t, async_exch_t *);
 extern bool async_state_change_receive(cap_handle_t *, sysarg_t *, sysarg_t *,
     sysarg_t *);
-extern errno_t async_state_change_finalize(cap_handle_t, async_exch_t *);
+extern int async_state_change_finalize(cap_handle_t, async_exch_t *);
 
 extern void *async_remote_state_acquire(async_sess_t *);
Index: uspace/lib/c/include/bd.h
===================================================================
--- uspace/lib/c/include/bd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/bd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,12 +43,12 @@
 } bd_t;
 
-extern errno_t bd_open(async_sess_t *, bd_t **);
+extern int bd_open(async_sess_t *, bd_t **);
 extern void bd_close(bd_t *);
-extern errno_t bd_read_blocks(bd_t *, aoff64_t, size_t, void *, size_t);
-extern errno_t bd_read_toc(bd_t *, uint8_t, void *, size_t);
-extern errno_t bd_write_blocks(bd_t *, aoff64_t, size_t, const void *, size_t);
-extern errno_t bd_sync_cache(bd_t *, aoff64_t, size_t);
-extern errno_t bd_get_block_size(bd_t *, size_t *);
-extern errno_t bd_get_num_blocks(bd_t *, aoff64_t *);
+extern int bd_read_blocks(bd_t *, aoff64_t, size_t, void *, size_t);
+extern int bd_read_toc(bd_t *, uint8_t, void *, size_t);
+extern int bd_write_blocks(bd_t *, aoff64_t, size_t, const void *, size_t);
+extern int bd_sync_cache(bd_t *, aoff64_t, size_t);
+extern int bd_get_block_size(bd_t *, size_t *);
+extern int bd_get_num_blocks(bd_t *, aoff64_t *);
 
 #endif
Index: uspace/lib/c/include/bd_srv.h
===================================================================
--- uspace/lib/c/include/bd_srv.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/bd_srv.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,17 +58,17 @@
 
 struct bd_ops {
-	errno_t (*open)(bd_srvs_t *, bd_srv_t *);
-	errno_t (*close)(bd_srv_t *);
-	errno_t (*read_blocks)(bd_srv_t *, aoff64_t, size_t, void *, size_t);
-	errno_t (*read_toc)(bd_srv_t *, uint8_t, void *, size_t);
-	errno_t (*sync_cache)(bd_srv_t *, aoff64_t, size_t);
-	errno_t (*write_blocks)(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
-	errno_t (*get_block_size)(bd_srv_t *, size_t *);
-	errno_t (*get_num_blocks)(bd_srv_t *, aoff64_t *);
+	int (*open)(bd_srvs_t *, bd_srv_t *);
+	int (*close)(bd_srv_t *);
+	int (*read_blocks)(bd_srv_t *, aoff64_t, size_t, void *, size_t);
+	int (*read_toc)(bd_srv_t *, uint8_t, void *, size_t);
+	int (*sync_cache)(bd_srv_t *, aoff64_t, size_t);
+	int (*write_blocks)(bd_srv_t *, aoff64_t, size_t, const void *, size_t);
+	int (*get_block_size)(bd_srv_t *, size_t *);
+	int (*get_num_blocks)(bd_srv_t *, aoff64_t *);
 };
 
 extern void bd_srvs_init(bd_srvs_t *);
 
-extern errno_t bd_conn(ipc_callid_t, ipc_call_t *, bd_srvs_t *);
+extern int bd_conn(ipc_callid_t, ipc_call_t *, bd_srvs_t *);
 
 #endif
Index: uspace/lib/c/include/cap.h
===================================================================
--- uspace/lib/c/include/cap.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/cap.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -90,9 +90,9 @@
 } cap_spec_t;
 
-extern errno_t cap_format(cap_spec_t *, char **);
-extern errno_t cap_parse(const char *, cap_spec_t *);
+extern int cap_format(cap_spec_t *, char **);
+extern int cap_parse(const char *, cap_spec_t *);
 extern void cap_simplify(cap_spec_t *);
 extern void cap_from_blocks(uint64_t, size_t, cap_spec_t *);
-extern errno_t cap_to_blocks(cap_spec_t *, cap_vsel_t, size_t, uint64_t *);
+extern int cap_to_blocks(cap_spec_t *, cap_vsel_t, size_t, uint64_t *);
 
 #endif
Index: uspace/lib/c/include/clipboard.h
===================================================================
--- uspace/lib/c/include/clipboard.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/clipboard.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,6 +36,6 @@
 #define LIBC_CLIPBOARD_H_
 
-extern errno_t clipboard_put_str(const char *);
-extern errno_t clipboard_get_str(char **);
+extern int clipboard_put_str(const char *);
+extern int clipboard_get_str(char **);
 
 #endif
Index: uspace/lib/c/include/corecfg.h
===================================================================
--- uspace/lib/c/include/corecfg.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/corecfg.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,10 +36,9 @@
 #define LIBC_CORECFG_H_
 
-#include <errno.h>
 #include <stdbool.h>
 
-extern errno_t corecfg_init(void);
-extern errno_t corecfg_set_enable(bool);
-extern errno_t corecfg_get_enable(bool *);
+extern int corecfg_init(void);
+extern int corecfg_set_enable(bool);
+extern int corecfg_get_enable(bool *);
 
 #endif
Index: uspace/lib/c/include/ctype.h
===================================================================
--- uspace/lib/c/include/ctype.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ctype.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,24 +61,4 @@
 }
 
-static inline int isblank(int c)
-{
-	return c == ' ' || c == '\t';
-}
-
-static inline int iscntrl(int c)
-{
-	return (c >= 0 && c < 0x20) || c == 0x7E;
-}
-
-static inline int isprint(int c)
-{
-	return c >= 0 && c < 0x80 && !iscntrl(c);
-}
-
-static inline int isgraph(int c)
-{
-	return isprint(c) && c != ' ';
-}
-
 static inline int isspace(int c)
 {
@@ -95,16 +75,4 @@
 		return 0;
 	}
-}
-
-static inline int ispunct(int c)
-{
-	return !isspace(c) && !isalnum(c) && isprint(c);
-}
-
-static inline int isxdigit(int c)
-{
-	return isdigit(c) ||
-	    (c >= 'a' && c <= 'f') ||
-	    (c >= 'A' && c <= 'F');
 }
 
Index: uspace/lib/c/include/ddi.h
===================================================================
--- uspace/lib/c/include/ddi.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ddi.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,22 +54,22 @@
 typedef volatile uint64_t ioport64_t;
 
-extern errno_t physmem_map(uintptr_t, size_t, unsigned int, void **);
-extern errno_t physmem_unmap(void *);
+extern int physmem_map(uintptr_t, size_t, unsigned int, void **);
+extern int physmem_unmap(void *);
 
-extern errno_t dmamem_map(void *, size_t, unsigned int, unsigned int, uintptr_t *);
-extern errno_t dmamem_map_anonymous(size_t, uintptr_t, unsigned int, unsigned int,
+extern int dmamem_map(void *, size_t, unsigned int, unsigned int, uintptr_t *);
+extern int dmamem_map_anonymous(size_t, uintptr_t, unsigned int, unsigned int,
     uintptr_t *, void **);
-extern errno_t dmamem_unmap(void *, size_t);
-extern errno_t dmamem_unmap_anonymous(void *);
+extern int dmamem_unmap(void *, size_t);
+extern int dmamem_unmap_anonymous(void *);
 
-extern errno_t pio_enable_range(addr_range_t *, void **);
-extern errno_t pio_enable_resource(pio_window_t *, hw_resource_t *, void **);
-extern errno_t pio_enable(void *, size_t, void **);
-extern errno_t pio_disable(void *, size_t);
+extern int pio_enable_range(addr_range_t *, void **);
+extern int pio_enable_resource(pio_window_t *, hw_resource_t *, void **);
+extern int pio_enable(void *, size_t, void **);
+extern int pio_disable(void *, size_t);
 
 typedef void (*trace_fnc)(const volatile void *place, uint64_t val,
     volatile void* base, size_t size, void *data, bool write);
 
-extern errno_t pio_trace_enable(void *, size_t, trace_fnc, void *);
+extern int pio_trace_enable(void *, size_t, trace_fnc, void *);
 extern void pio_trace_log(const volatile void *, uint64_t val, bool write);
 extern void pio_trace_disable(void *);
Index: uspace/lib/c/include/device/clock_dev.h
===================================================================
--- uspace/lib/c/include/device/clock_dev.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/device/clock_dev.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,6 +44,6 @@
 } clock_dev_method_t;
 
-extern errno_t clock_dev_time_get(async_sess_t *, struct tm *);
-extern errno_t clock_dev_time_set(async_sess_t *, struct tm *);
+extern int clock_dev_time_get(async_sess_t *, struct tm *);
+extern int clock_dev_time_set(async_sess_t *, struct tm *);
 
 #endif
Index: uspace/lib/c/include/device/hw_res.h
===================================================================
--- uspace/lib/c/include/device/hw_res.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/device/hw_res.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -116,12 +116,12 @@
 }
 
-extern errno_t hw_res_get_resource_list(async_sess_t *, hw_resource_list_t *);
-extern errno_t hw_res_enable_interrupt(async_sess_t *, int);
-extern errno_t hw_res_disable_interrupt(async_sess_t *, int);
-extern errno_t hw_res_clear_interrupt(async_sess_t *, int);
+extern int hw_res_get_resource_list(async_sess_t *, hw_resource_list_t *);
+extern int hw_res_enable_interrupt(async_sess_t *, int);
+extern int hw_res_disable_interrupt(async_sess_t *, int);
+extern int hw_res_clear_interrupt(async_sess_t *, int);
 
-extern errno_t hw_res_dma_channel_setup(async_sess_t *, unsigned int, uint32_t,
+extern int hw_res_dma_channel_setup(async_sess_t *, unsigned int, uint32_t,
     uint32_t, uint8_t);
-extern errno_t hw_res_dma_channel_remain(async_sess_t *, unsigned, size_t *);
+extern int hw_res_dma_channel_remain(async_sess_t *, unsigned);
 
 #endif
Index: uspace/lib/c/include/device/hw_res_parsed.h
===================================================================
--- uspace/lib/c/include/device/hw_res_parsed.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/device/hw_res_parsed.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -154,7 +154,7 @@
 }
 
-extern errno_t hw_res_list_parse(const pio_window_t *, const hw_resource_list_t *,
+extern int hw_res_list_parse(const pio_window_t *, const hw_resource_list_t *,
     hw_res_list_parsed_t *, int);
-extern errno_t hw_res_get_list_parsed(async_sess_t *, hw_res_list_parsed_t *, int);
+extern int hw_res_get_list_parsed(async_sess_t *, hw_res_list_parsed_t *, int);
 
 #endif
Index: uspace/lib/c/include/device/led_dev.h
===================================================================
--- uspace/lib/c/include/device/led_dev.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/device/led_dev.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 } led_dev_method_t;
 
-extern errno_t led_dev_color_set(async_sess_t *, pixel_t);
+extern int led_dev_color_set(async_sess_t *, pixel_t);
 
 #endif
Index: uspace/lib/c/include/device/pio_window.h
===================================================================
--- uspace/lib/c/include/device/pio_window.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/device/pio_window.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,5 +51,5 @@
 } pio_window_t;
 
-extern errno_t pio_window_get(async_sess_t *, pio_window_t *);
+extern int pio_window_get(async_sess_t *, pio_window_t *);
 
 #endif
Index: uspace/lib/c/include/devman.h
===================================================================
--- uspace/lib/c/include/devman.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/devman.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,10 +46,10 @@
 extern void devman_exchange_end(async_exch_t *);
 
-extern errno_t devman_driver_register(const char *);
-extern errno_t devman_add_function(const char *, fun_type_t, match_id_list_t *,
+extern int devman_driver_register(const char *);
+extern int devman_add_function(const char *, fun_type_t, match_id_list_t *,
     devman_handle_t, devman_handle_t *);
-extern errno_t devman_remove_function(devman_handle_t);
-extern errno_t devman_drv_fun_online(devman_handle_t);
-extern errno_t devman_drv_fun_offline(devman_handle_t);
+extern int devman_remove_function(devman_handle_t);
+extern int devman_drv_fun_online(devman_handle_t);
+extern int devman_drv_fun_offline(devman_handle_t);
 
 extern async_sess_t *devman_device_connect(devman_handle_t, unsigned int);
@@ -57,30 +57,30 @@
     unsigned int);
 
-extern errno_t devman_fun_get_handle(const char *, devman_handle_t *,
+extern int devman_fun_get_handle(const char *, devman_handle_t *,
     unsigned int);
-extern errno_t devman_fun_get_child(devman_handle_t, devman_handle_t *);
-extern errno_t devman_dev_get_parent(devman_handle_t, devman_handle_t *);
-extern errno_t devman_dev_get_functions(devman_handle_t, devman_handle_t **,
+extern int devman_fun_get_child(devman_handle_t, devman_handle_t *);
+extern int devman_dev_get_parent(devman_handle_t, devman_handle_t *);
+extern int devman_dev_get_functions(devman_handle_t, devman_handle_t **,
     size_t *);
-extern errno_t devman_fun_get_match_id(devman_handle_t, size_t, char *, size_t,
+extern int devman_fun_get_match_id(devman_handle_t, size_t, char *, size_t,
     unsigned int *);
-extern errno_t devman_fun_get_name(devman_handle_t, char *, size_t);
-extern errno_t devman_fun_get_driver_name(devman_handle_t, char *, size_t);
-extern errno_t devman_fun_get_path(devman_handle_t, char *, size_t);
-extern errno_t devman_fun_online(devman_handle_t);
-extern errno_t devman_fun_offline(devman_handle_t);
+extern int devman_fun_get_name(devman_handle_t, char *, size_t);
+extern int devman_fun_get_driver_name(devman_handle_t, char *, size_t);
+extern int devman_fun_get_path(devman_handle_t, char *, size_t);
+extern int devman_fun_online(devman_handle_t);
+extern int devman_fun_offline(devman_handle_t);
 
-extern errno_t devman_add_device_to_category(devman_handle_t, const char *);
-extern errno_t devman_fun_sid_to_handle(service_id_t, devman_handle_t *);
-extern errno_t devman_get_drivers(devman_handle_t **, size_t *);
-extern errno_t devman_driver_get_devices(devman_handle_t, devman_handle_t **,
+extern int devman_add_device_to_category(devman_handle_t, const char *);
+extern int devman_fun_sid_to_handle(service_id_t, devman_handle_t *);
+extern int devman_get_drivers(devman_handle_t **, size_t *);
+extern int devman_driver_get_devices(devman_handle_t, devman_handle_t **,
     size_t *);
-extern errno_t devman_driver_get_handle(const char *, devman_handle_t *);
-extern errno_t devman_driver_get_match_id(devman_handle_t, size_t, char *, size_t,
+extern int devman_driver_get_handle(const char *, devman_handle_t *);
+extern int devman_driver_get_match_id(devman_handle_t, size_t, char *, size_t,
     unsigned int *);
-extern errno_t devman_driver_get_name(devman_handle_t, char *, size_t);
-extern errno_t devman_driver_get_state(devman_handle_t, driver_state_t *);
-extern errno_t devman_driver_load(devman_handle_t);
-extern errno_t devman_driver_unload(devman_handle_t);
+extern int devman_driver_get_name(devman_handle_t, char *, size_t);
+extern int devman_driver_get_state(devman_handle_t, driver_state_t *);
+extern int devman_driver_load(devman_handle_t);
+extern int devman_driver_unload(devman_handle_t);
 
 #endif
Index: uspace/lib/c/include/elf/elf_mod.h
===================================================================
--- uspace/lib/c/include/elf/elf_mod.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/elf/elf_mod.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,5 +53,4 @@
 #define EE_LOADER		5	/* The image is actually a program loader. */
 #define EE_IRRECOVERABLE	6
-#define EE_IO			7	/* Could not read file. */
 
 typedef enum {
Index: uspace/lib/c/include/errno.h
===================================================================
--- uspace/lib/c/include/errno.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/errno.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define LIBC_ERRNO_H_
 
-#include <_bits/errno.h>
 #include <abi/errno.h>
 
Index: uspace/lib/c/include/fibril.h
===================================================================
--- uspace/lib/c/include/fibril.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/fibril.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -71,9 +71,9 @@
 	void *stack;
 	void *arg;
-	errno_t (*func)(void *);
+	int (*func)(void *);
 	tcb_t *tcb;
 	
 	struct fibril *clean_after_me;
-	errno_t retval;
+	int retval;
 	int flags;
 	
@@ -93,5 +93,5 @@
 #define fibril_create(func, arg) \
 	fibril_create_generic((func), (arg), FIBRIL_DFLT_STK_SIZE)
-extern fid_t fibril_create_generic(errno_t (*func)(void *), void *arg, size_t);
+extern fid_t fibril_create_generic(int (*func)(void *), void *arg, size_t);
 extern void fibril_destroy(fid_t fid);
 extern fibril_t *fibril_setup(void);
@@ -102,4 +102,7 @@
 extern void fibril_remove_manager(void);
 extern fid_t fibril_get_id(void);
+extern void fibril_inc_sercount(void);
+extern void fibril_dec_sercount(void);
+extern int fibril_get_sercount(void);
 
 static inline int fibril_yield(void)
Index: uspace/lib/c/include/fibril_synch.h
===================================================================
--- uspace/lib/c/include/fibril_synch.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/fibril_synch.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -159,5 +159,5 @@
 
 extern void fibril_condvar_initialize(fibril_condvar_t *);
-extern errno_t fibril_condvar_wait_timeout(fibril_condvar_t *, fibril_mutex_t *,
+extern int fibril_condvar_wait_timeout(fibril_condvar_t *, fibril_mutex_t *,
     suseconds_t);
 extern void fibril_condvar_wait(fibril_condvar_t *, fibril_mutex_t *);
Index: uspace/lib/c/include/futex.h
===================================================================
--- uspace/lib/c/include/futex.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/futex.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 
 #include <atomic.h>
-#include <errno.h>
 #include <libc.h>
 
@@ -108,9 +107,9 @@
  * @param futex Futex.
  *
- * @return true if the futex was acquired.
- * @return false if the futex was not acquired.
+ * @return Non-zero if the futex was acquired.
+ * @return Zero if the futex was not acquired.
  *
  */
-static inline bool futex_trydown(futex_t *futex)
+static inline int futex_trydown(futex_t *futex)
 {
 	return cas(&futex->val, 1, 0);
@@ -122,14 +121,14 @@
  *
  * @return ENOENT if there is no such virtual address.
- * @return EOK on success.
- * @return Error code from <errno.h> otherwise.
+ * @return Zero in the uncontended case.
+ * @return Otherwise one of ESYNCH_OK_ATOMIC or ESYNCH_OK_BLOCKED.
  *
  */
-static inline errno_t futex_down(futex_t *futex)
+static inline int futex_down(futex_t *futex)
 {
 	if ((atomic_signed_t) atomic_predec(&futex->val) < 0)
-		return (errno_t) __SYSCALL1(SYS_FUTEX_SLEEP, (sysarg_t) &futex->val.count);
+		return __SYSCALL1(SYS_FUTEX_SLEEP, (sysarg_t) &futex->val.count);
 	
-	return EOK;
+	return 0;
 }
 
@@ -139,14 +138,13 @@
  *
  * @return ENOENT if there is no such virtual address.
- * @return EOK on success.
- * @return Error code from <errno.h> otherwise.
+ * @return Zero in the uncontended case.
  *
  */
-static inline errno_t futex_up(futex_t *futex)
+static inline int futex_up(futex_t *futex)
 {
 	if ((atomic_signed_t) atomic_postinc(&futex->val) < 0)
-		return (errno_t) __SYSCALL1(SYS_FUTEX_WAKEUP, (sysarg_t) &futex->val.count);
+		return __SYSCALL1(SYS_FUTEX_WAKEUP, (sysarg_t) &futex->val.count);
 	
-	return EOK;
+	return 0;
 }
 
Index: uspace/lib/c/include/getopt.h
===================================================================
--- uspace/lib/c/include/getopt.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/getopt.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,5 +57,5 @@
 
 /* HelenOS Port - These need to be exposed for legacy getopt() */
-extern char *optarg;
+extern const char *optarg;
 extern int optind, opterr, optopt;
 extern int optreset;
Index: uspace/lib/c/include/imath.h
===================================================================
--- uspace/lib/c/include/imath.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/imath.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include <stdint.h>
 
-extern errno_t ipow10_u64(unsigned, uint64_t *);
+extern int ipow10_u64(unsigned, uint64_t *);
 extern unsigned ilog10_u64(uint64_t);
 
Index: uspace/lib/c/include/inet/addr.h
===================================================================
--- uspace/lib/c/include/inet/addr.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/addr.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define LIBC_INET_ADDR_H_
 
-#include <errno.h>
 #include <stdint.h>
 
@@ -112,9 +111,9 @@
 extern int inet_naddr_compare_mask(const inet_naddr_t *, const inet_addr_t *);
 
-extern errno_t inet_addr_parse(const char *, inet_addr_t *, char **);
-extern errno_t inet_naddr_parse(const char *, inet_naddr_t *, char **);
+extern int inet_addr_parse(const char *, inet_addr_t *, char **);
+extern int inet_naddr_parse(const char *, inet_naddr_t *, char **);
 
-extern errno_t inet_addr_format(const inet_addr_t *, char **);
-extern errno_t inet_naddr_format(const inet_naddr_t *, char **);
+extern int inet_addr_format(const inet_addr_t *, char **);
+extern int inet_naddr_format(const inet_naddr_t *, char **);
 
 extern ip_ver_t inet_addr_get(const inet_addr_t *, addr32_t *, addr128_t *);
Index: uspace/lib/c/include/inet/dhcp.h
===================================================================
--- uspace/lib/c/include/inet/dhcp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/dhcp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,8 +38,8 @@
 #include <types/common.h>
 
-extern errno_t dhcp_init(void);
-extern errno_t dhcp_link_add(sysarg_t);
-extern errno_t dhcp_link_remove(sysarg_t);
-extern errno_t dhcp_discover(sysarg_t);
+extern int dhcp_init(void);
+extern int dhcp_link_add(sysarg_t);
+extern int dhcp_link_remove(sysarg_t);
+extern int dhcp_discover(sysarg_t);
 
 #endif
Index: uspace/lib/c/include/inet/dnsr.h
===================================================================
--- uspace/lib/c/include/inet/dnsr.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/dnsr.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,9 +50,9 @@
 } dnsr_hostinfo_t;
 
-extern errno_t dnsr_init(void);
-extern errno_t dnsr_name2host(const char *, dnsr_hostinfo_t **, ip_ver_t);
+extern int dnsr_init(void);
+extern int dnsr_name2host(const char *, dnsr_hostinfo_t **, ip_ver_t);
 extern void dnsr_hostinfo_destroy(dnsr_hostinfo_t *);
-extern errno_t dnsr_get_srvaddr(inet_addr_t *);
-extern errno_t dnsr_set_srvaddr(inet_addr_t *);
+extern int dnsr_get_srvaddr(inet_addr_t *);
+extern int dnsr_set_srvaddr(inet_addr_t *);
 
 #endif
Index: uspace/lib/c/include/inet/host.h
===================================================================
--- uspace/lib/c/include/inet/host.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/host.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,9 +40,9 @@
 #include <types/inet/hostport.h>
 
-extern errno_t inet_host_parse(const char *, inet_host_t **, char **);
-extern errno_t inet_host_format(inet_host_t *, char **);
+extern int inet_host_parse(const char *, inet_host_t **, char **);
+extern int inet_host_format(inet_host_t *, char **);
 extern void inet_host_destroy(inet_host_t *);
-extern errno_t inet_host_lookup_one(inet_host_t *, ip_ver_t, inet_addr_t *);
-extern errno_t inet_host_plookup_one(const char *, ip_ver_t, inet_addr_t *,
+extern int inet_host_lookup_one(inet_host_t *, ip_ver_t, inet_addr_t *);
+extern int inet_host_plookup_one(const char *, ip_ver_t, inet_addr_t *,
     char **, const char **);
 
Index: uspace/lib/c/include/inet/hostname.h
===================================================================
--- uspace/lib/c/include/inet/hostname.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/inet/hostname.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,5 @@
 #define LIBC_INET_HOSTNAME_H_
 
-extern errno_t inet_hostname_parse(const char *, char **, char **);
+extern int inet_hostname_parse(const char *, char **, char **);
 
 #endif
